' FirefoxADM 0.5.9.3
' 2004/2005/2008/2009 Mark Sammons
' URL Security check code by Michael Morandi, 2005
' Delete Private Data Cookies, Delete Private Data Offline Websites, Delete Private Data Passwords, Show SSL Domain Icon,
' Use Download Directory, Replace Certificates for all User Profiles code by Florian Baenziger, 2009
' Suppression of Firefox update page by Nathan Przybyszewski, 2009

' create shell instance
set WshShell = WScript.CreateObject("WScript.Shell")

' create file object instances
set fso = CreateObject("Scripting.FileSystemObject")

' variables I'll be needing later
Const ForReading = 1, ForWriting = 2, ForAppending = 8
Dim FirefoxProfilePath, FirefoxPrefsFile, FirefoxProfileFolder, FirefoxProfiles
Dim FirefoxFolder, PrefsFile
Dim ParsePrefsFile, ParseOutPrefsFile
Dim FolderCreate, FirefoxProfileIniFile, FirefoxEmptyPrefsFile
' and this list needed for each feature
Dim HomePageKey, SearchEngineKey, ImageResizeKey, ProxyKey, ProxyURLKey
Dim HTTPKey, HTTPPortKey, SSLKey, SSLPortKey, FTPKey, FTPPortKey
Dim GopherKey, GopherPortKey, SOCKSKey, SOCKSPortKey, SOCKSVersionKey, ProxyExceptionsKey, ExceptionSplit
Dim FirefoxUseIEKey, IESettingFile, ParseFileLine, ParseSplitLine, ParseSplitSetting, SameProxy
Dim NetscapeJscFile, FirefoxJsFile

on error resume next 

set EnVar = Wshshell.environment("Process")

' Files To Use
FirefoxUseRegLoc = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxUseRegLoc")
if FirefoxUseRegLoc = "yes" then
	' get location
	FirefoxVersion = WshShell.regread("HKLM\Software\Mozilla\Mozilla Firefox\CurrentVersion")
	FirefoxFilePath = WshShell.regread("HKLM\Software\Mozilla\Mozilla Firefox\" & FirefoxVersion & "\Main\Install Directory")

	' if can't find, use default
	if FirefoxFilePath = "" then
		FirefoxFilePath = EnVar("ProgramFiles") & "\Mozilla Firefox"
	end if

	' set paths
	FirefoxPrefsFile = FirefoxFilePath & "\defaults\autoconfig\prefcalls.js"
	NetscapeJscFile = FirefoxFilePath & "\netscape.jsc"
	FirefoxJsFile = FirefoxFilePath & "\defaults\pref\firefox.js"
	FirefoxAllJsFile = FirefoxFilePath & "\greprefs\all.js"
	FirefoxXpinstallJsFile = FirefoxFilePath & "\greprefs\xpinstall.js"
	FirefoxBrowserconfigPropertiesFile = FirefoxFilePath & "\browserconfig.properties"
else
	FirefoxPrefsFile = EnVar("ProgramFiles") & "\Mozilla Firefox\defaults\autoconfig\prefcalls.js"
	NetscapeJscFile = EnVar("ProgramFiles") & "\Mozilla Firefox\netscape.jsc"
	FirefoxJsFile = EnVar("ProgramFiles") & "\Mozilla Firefox\defaults\pref\firefox.js"
	FirefoxAllJsFile = EnVar("ProgramFiles") & "\Mozilla Firefox\greprefs\all.js"
	FirefoxXpinstallJsFile = EnVar("ProgramFiles") & "\Mozilla Firefox\greprefs\xpinstall.js"
	FirefoxBrowserconfigPropertiesFile = EnVar("ProgramFiles") & "\Mozilla Firefox\browserconfig.properties"
end if


' check for the Netscape locking file
if fso.FileExists(NetscapeJscFile) then
	' do nothing
else
	' create locking file
	Set NetscapeJscFileSet = fso.OpenTextFile(NetscapeJscFile, ForWriting, True)
  	NetscapeJscFileSet.Write("created by FirefoxADM")
	NetscapeJscFileSet.Close
end if

RemoveConfigSetting()

' add in netscape.jsc locking variable
Set FirefoxJsFileSet = fso.OpenTextFile(FirefoxJsFile, ForAppending)
FirefoxJsFileSet.Write(vbCrLf & "pref(" & chr(34) & "general.config.filename" & chr(34) & "," & chr(34) & "netscape.jsc" & chr(34) & ");")
FirefoxJsFileSet.Close


'  ------------------
'  Begin the Settings
'  ------------------


' homepage setting
if FirefoxUseIEKey <> "1" then 
	HomePageTypeKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxHomepageType")
	HomePageKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxHomepage")
	HomePagePageKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxHomepagePage")
end if
if HomePageKey <> "" then
	RemoveCurrentPrefsFromFile("browser.startup.homepage")
	if HomePageTypeKey = "default" then
		SetDefaultHomePage(HomePageKey)
	else
		set HomePageSet = AppendPrefsToFile("browser.startup.homepage", chr(34) & HomePageKey & chr(34))
	end if
end if
if HomePagePageKey <> "" then
	RemoveCurrentPrefsFromFile("browser.startup.page")
	if HomePageTypeKey = "default" then
		set HomePagePageSet = AppendDefaultToFile("browser.startup.page", HomePagePageKey)
	else
		set HomePagePageSet = AppendPrefsToFile("browser.startup.page", HomePagePageKey)
	end if
end if


' Automatic Image Resizing
ImageResizeTypeKey = WshShell.regread("HKLM\Software\Policies\Firefox\ImageResizeType")
ImageResizeKey = WshShell.regread("HKLM\Software\Policies\Firefox\ImageResize")
if ImageResizeKey <> "" then
	RemoveCurrentPrefsFromFile("browser.enable_automatic_image_resizing")
	if ImageResizeTypeKey = "default" then
		RemovePrefFromFirefoxJs("browser.enable_automatic_image_resizing")
		if ImageResizeKey = "0" then
			set SearchEngineSet = AppendDefaultToFile("browser.enable_automatic_image_resizing", "false")
		else
			set SearchEngineSet = AppendDefaultToFile("browser.enable_automatic_image_resizing", "true")
		end if
	else
		if ImageResizeKey = "0" then
			set SearchEngineSet = AppendPrefsToFile("browser.enable_automatic_image_resizing", "false")
		else
			set SearchEngineSet = AppendPrefsToFile("browser.enable_automatic_image_resizing", "true")
		end if
	end if
end if
		

' Proxy Settings
FirefoxProxyType = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxProxyType")
ProxyKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxProxy")
ProxyURLKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxAutoProxyURL")
HTTPKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxManualHTTP")
HTTPPortKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxManualHTTPPort")
SSLKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxManualSSL")
SSLPortKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxManualSSLPort")
FTPKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxManualFTP")
FTPPortKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxManualFTPPort")
GopherKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxManualGopher")
GopherPortKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxManualGopherPort")
SOCKSKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxManualSOCKS")
SOCKSPortKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxManualSOCKSPort")
ProxyExceptionsKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxProxyExceptions")
if ProxyKey <> "" then
	SOCKSVersionKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxManualSOCKSVersion")
	removeCurrentPrefsFromFile("network.proxy.type")
	removeCurrentPrefsFromFile("network.proxy.autoconfig_url")
	removeCurrentPrefsFromFile("network.proxy.http")
	removeCurrentPrefsFromFile("network.proxy.http_port")
	removeCurrentPrefsFromFile("network.proxy.ssl")
	removeCurrentPrefsFromFile("network.proxy.ssl_port")
	removeCurrentPrefsFromFile("network.proxy.ftp")
	removeCurrentPrefsFromFile("network.proxy.ftp_port")
	removeCurrentPrefsFromFile("network.proxy.gopher")
	removeCurrentPrefsFromFile("network.proxy.gopher_port")
	removeCurrentPrefsFromFile("network.proxy.socks")
	removeCurrentPrefsFromFile("network.proxy.socks_port")
	removeCurrentPrefsFromFile("network.proxy.socks_version")
	removeCurrentPrefsFromFile("network.proxy.no_proxies_on")
	if FirefoxProxyType = "default" then
		RemovePrefFromAllJs("network.proxy.type")
		RemovePrefFromAllJs("network.proxy.autoconfig_url")
		RemovePrefFromAllJs("network.proxy.http")
		RemovePrefFromAllJs("network.proxy.http_port")
		RemovePrefFromAllJs("network.proxy.ssl")
		RemovePrefFromAllJs("network.proxy.ssl_port")
		RemovePrefFromAllJs("network.proxy.ftp")
		RemovePrefFromAllJs("network.proxy.ftp_port")
		RemovePrefFromAllJs("network.proxy.gopher")
		RemovePrefFromAllJs("network.proxy.gopher_port")
		RemovePrefFromAllJs("network.proxy.socks_port")
		RemovePrefFromAllJs("network.proxy.socks_version")
		RemovePrefFromAllJs("network.proxy.no_proxies_on")
		if ProxyURLKey <> "" then
			set ProxyURLSet = AppendDefaultToFile("network.proxy.autoconfig_url", chr(34) & ProxyURLKey & chr(34))
		end if
		if HTTPKey <> "" then
			set HTTPSet = AppendDefaultToFile("network.proxy.http", chr(34) & HTTPKey & chr(34))
			HTTPSet = AppendDefaultToFile("network.proxy.http_port", HTTPPortKey)
		end if
		if SSLKey <> "" then
			set SSLSet = AppendDefaultToFile("network.proxy.ssl", chr(34) & SSLKey & chr(34))
			SSLSet = AppendDefaultToFile("network.proxy.ssl_port", SSLPortKey)
		end if
		if FTPKey <> "" then
			set FTPSet = AppendDefaultToFile("network.proxy.ftp", chr(34) & FTPKey & chr(34))
			FTPSet = AppendDefaultToFile("network.proxy.ftp_port", FTPPortKey)
		end if
		if GopherKey <> "" then
			set GopherSet = AppendDefaultToFile("network.proxy.gopher", chr(34) & GopherKey & chr(34))
			GopherSet = AppendDefaultToFile("network.proxy.gopher_port", GopherPortKey)
		end if
		if SOCKSKey <> "" then
			set SOCKSSet = AppendDefaultToFile("network.proxy.socks", chr(34) & SOCKSKey & chr(34))
			SOCKSSet = AppendDefaultToFile("network.proxy.socks_port", SOCKSPortKey)
			SOCKSSet = AppendDefaultToFile("network.proxy.socks_version", SOCKSVersionKey)
		end if
		if ProxyExceptionsKey <> "localhost, 127.0.0.1" or ProxyExceptions <> "" then
			set ExceptionsSet = AppendDefaultToFile("network.proxy.no_proxies_on", chr(34) & ProxyExceptionsKey & chr(34))
		Elseif ProxyExceptionsKey = "localhost, 127.0.0.1" then
			set ExceptionsSet = AppendDefaultToFile("network.proxy.no_proxies_on", chr(34) & ProxyExceptionsKey & chr(34))
		end if
		set ProxySet = AppendDefaultToFile("network.proxy.type", ProxyKey)
	else
		if ProxyURLKey <> "" then
			set ProxyURLSet = AppendPrefsToFile("network.proxy.autoconfig_url", chr(34) & ProxyURLKey & chr(34))
		end if
		if HTTPKey <> "" then
			set HTTPSet = AppendPrefsToFile("network.proxy.http", chr(34) & HTTPKey & chr(34))
			HTTPSet = AppendPrefsToFile("network.proxy.http_port", HTTPPortKey)
		end if
		if SSLKey <> "" then
			set SSLSet = AppendPrefsToFile("network.proxy.ssl", chr(34) & SSLKey & chr(34))
			SSLSet = AppendPrefsToFile("network.proxy.ssl_port", SSLPortKey)
		end if
		if FTPKey <> "" then
			set FTPSet = AppendPrefsToFile("network.proxy.ftp", chr(34) & FTPKey & chr(34))
			FTPSet = AppendPrefsToFile("network.proxy.ftp_port", FTPPortKey)
		end if
		if GopherKey <> "" then
			set GopherSet = AppendPrefsToFile("network.proxy.gopher", chr(34) & GopherKey & chr(34))
			GopherSet = AppendPrefsToFile("network.proxy.gopher_port", GopherPortKey)
		end if
		if SOCKSKey <> "" then
			set SOCKSSet = AppendPrefsToFile("network.proxy.socks", chr(34) & SOCKSKey & chr(34))
			SOCKSSet = AppendPrefsToFile("network.proxy.socks_port", SOCKSPortKey)
			SOCKSSet = AppendPrefsToFile("network.proxy.socks_version", SOCKSVersionKey)
		end if
		if ProxyExceptionsKey <> "localhost, 127.0.0.1" or ProxyExceptions <> "" then
			set ExceptionsSet = AppendPrefsToFile("network.proxy.no_proxies_on", chr(34) & ProxyExceptionsKey & chr(34))
		Elseif ProxyExceptionsKey = "localhost, 127.0.0.1" then
			set ExceptionsSet = AppendPrefsToFile("network.proxy.no_proxies_on", chr(34) & ProxyExceptionsKey & chr(34))
		end if
		set ProxySet = AppendPrefsToFile("network.proxy.type", ProxyKey)
	end if
end if


' Cache
FirefoxCacheType = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxCacheType")
FirefoxCacheKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxCacheSize")
FirefoxCacheSSLKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxCacheSSL")
if FirefoxCacheKey <> "" then
	RemoveCurrentPrefsFromFile("browser.cache.disk.capacity")
	RemoveCurrentPrefsFromFile("browser.cache.disk_cache_ssl")
	if FirefoxCacheType = "default" then
		RemovePrefFromAllJs("browser.cache.disk.capacity")
		RemovePrefFromFirefoxJs("browser.cache.disk.capacity")
		RemovePrefFromAllJs("browser.cache.disk_cache_ssl")
		set CacheSet = AppendDefaultToFile("browser.cache.disk.capacity", FirefoxCacheKey)
		if FirefoxCacheSSLKey = "1" then
			set CacheSSLSet = AppendDefaultToFile("browser.cache.disk_cache_ssl", "true")
		else
			set CacheSSLSet = AppendDefaultToFile("browser.cache.disk_cache_ssl", "false")
		end if
	else
		set CacheSet = AppendPrefsToFile("browser.cache.disk.capacity", FirefoxCacheKey)
		if FirefoxCacheSSLKey = "1" then
			set CacheSSLSet = AppendPrefsToFile("browser.cache.disk_cache_ssl", "true")
		else
			set CacheSSLSet = AppendPrefsToFile("browser.cache.disk_cache_ssl", "false")
		end if
	end if
end if


' Check Default Browser
FirefoxCheckDefaultType = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxCheckDefaultType")
FirefoxCheckDefaultKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxCheckDefault")
if FirefoxCheckDefaultKey = "0" then
	RemoveCurrentPrefsFromFile("browser.shell.checkDefaultBrowser")
	if FirefoxCheckDefaultType = "default" then
		RemovePrefFromFirefoxJs("browser.shell.checkDefaultBrowser")
		set DefaultSet = AppendDefaultToFile("browser.shell.checkDefaultBrowser", "false")
	else
		set DefaultSet = AppendPrefsToFile("browser.shell.checkDefaultBrowser", "false")
	end if
Elseif FirefoxCheckDefaultKey = "1" then
	RemoveCurrentPrefsFromFile("browser.shell.checkDefaultBrowser")
	if FirefoxCheckDefaultType = "default" then
		RemovePrefFromFirefoxJs("browser.shell.checkDefaultBrowser")
		set DefaultSet = AppendDefaultToFile("browser.shell.checkDefaultBrowser", "true")
	else
		set DefaultSet = AppendPrefsToFile("browser.shell.checkDefaultBrowser", "true")
	end if
end if


' Disable XPI Installations?
FirefoxXPIStateType = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxXPIStateType")
FirefoxXPIStateKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxXPIState")
if FirefoxXPIStateKey = "0" then
	RemoveCurrentPrefsFromFile("xpinstall.enabled")
	if FirefoxXPIStateType = "default" then
		RemovePrefFromXpinstallJs("xpinstall.enabled")
		set XPISet = AppendDefaultToFile("xpinstall.enabled", "false")
	else
		set XPISet = AppendPrefsToFile("xpinstall.enabled", "false")
	end if
Elseif FirefoxXPIStateKey = "1" then
	RemoveCurrentPrefsFromFile("xpinstall.enabled")
	if FirefoxXPIStateType = "default" then
		RemovePrefFromXpinstallJs("xpinstall.enabled")
		set XPISet = AppendDefaultToFile("xpinstall.enabled", "true")
	else
		set XPISet = AppendPrefsToFile("xpinstall.enabled", "true")
	end if
end if


' update Firefox
FirefoxUpdateStateKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxUpdateState")
If FirefoxUpdateStateKey = "1" then
	RemoveCurrentPrefsFromFile("app.update.autoUpdateEnabled")
	RemoveCurrentPrefsFromFile("app.update.enabled")
	set UpdateSet1 = AppendPrefsToFile("app.update.autoUpdateEnabled", "true")
	set UpdateSet2 = AppendPrefsToFile("app.update.enabled", "true")
ElseIf FirefoxUpdateStateKey = "0" then
	RemoveCurrentPrefsFromFile("app.update.autoUpdateEnabled")
	RemoveCurrentPrefsFromFile("app.update.enabled")
	set UpdateSet1 = AppendPrefsToFile("app.update.autoUpdateEnabled", "false")
	set UpdateSet2 = AppendPrefsToFile("app.update.enabled", "false")
end if


' update Firefox's extensions
FirefoxExtUpdateStateKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxExtUpdateState")
If FirefoxExtUpdateStateKey = "1" then
	RemoveCurrentPrefsFromFile("extensions.update.autoUpdateEnabled")
	RemoveCurrentPrefsFromFile("extensions.update.enabled")
	set UpdateXtSet1 = AppendPrefsToFile("extensions.update.autoUpdateEnabled", "true")
	set UpdateXtSet2 = AppendPrefsToFile("extensions.update.enabled", "true")
ElseIf FirefoxExtUpdateStateKey = "0" then
	RemoveCurrentPrefsFromFile("extensions.update.autoUpdate")
	RemoveCurrentPrefsFromFile("extensions.update.enabled")
	set UpdateXtSet1 = AppendPrefsToFile("extensions.update.autoUpdateEnabled", "false")
	set UpdateXtSet2 = AppendPrefsToFile("extensions.update.enabled", "false")
end if


' update Firefox's search engines
FirefoxSearchUpdateStateKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxSearchUpdateState")
If FirefoxSearchUpdateStateKey = "1" then
	RemoveCurrentPrefsFromFile("browser.search.update")
	set UpdateSearchSet = AppendPrefsToFile("browser.search.update", "true")
ElseIf FirefoxSearchUpdateStateKey = "0" then
	RemoveCurrentPrefsFromFile("browser.search.update")
	set UpdateSearchSet = AppendPrefsToFile("browser.search.update", "false")
end if


' Disable Java?
FirefoxJavaStateType = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxJavaStateType")
FirefoxJavaStateKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxJavaState")
If FirefoxJavaStateKey = "1" then
	RemoveCurrentPrefsFromFile("security.enable_java")
	If FirefoxJavaStateType = "default" then
		RemovePrefFromAllJs("security.enable_java")
		set JavaStateSet = AppendDefaultToFile("security.enable_java", "true")
	Else
		set JavaStateSet = AppendPrefsToFile("security.enable_java", "true")
	end if
ElseIf FirefoxJavaStateKey = "0" then
	RemoveCurrentPrefsFromFile("security.enable_java")
	If FirefoxJavaStateType = "default" then
		RemovePrefFromAllJs("security.enable_java")
		set JavaStateSet = AppendDefaultToFile("security.enable_java", "false")
	Else
		set JavaStateSet = AppendPrefsToFile("security.enable_java", "false")
	end if
end if


' Disable Javascript?
FirefoxJavascriptStateType = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxJavascriptStateType")
FirefoxJavascriptStateKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxJavascriptState")
If FirefoxJavascriptStateKey = "1" then
	RemoveCurrentPrefsFromFile("javascript.enabled")
	If FirefoxJavascriptStateType = "default" then
		RemovePrefFromAllJs("javascript.enabled")
		set JavascriptStateSet = AppendDefaultToFile("javascript.enabled", "true")
	Else
		set JavascriptStateSet = AppendPrefsToFile("javascript.enabled", "true")
	end if
ElseIf FirefoxJavascriptStateKey = "0" then
	RemoveCurrentPrefsFromFile("javascript.enabled")
	If FirefoxJavascriptStateType = "default" then
		RemovePrefFromAllJs("javascript.enabled")
		set JavascriptStateSet = AppendDefaultToFile("javascript.enabled", "false")
	Else
		set JavascriptStateSet = AppendPrefsToFile("javascript.enabled", "false")
	end if
end if


' Disable SSL 2/3 & TLS?
FirefoxSSLStateKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxSSLState")
If FirefoxSSLStateKey = "1" then
	RemoveCurrentPrefsFromFile("security.enable_ssl2")
	RemoveCurrentPrefsFromFile("security.enable_ssl3")
	RemoveCurrentPrefsFromFile("security.enable_tls")
	set SSLStateSet = AppendPrefsToFile("security.enable_ssl2", "true")
	set SSLStateSet = AppendPrefsToFile("security.enable_ssl3", "true")
	set SSLStateSet = AppendPrefsToFile("security.enable_tls", "true")
Elseif FirefoxSSLStateKey = "0" then
	RemoveCurrentPrefsFromFile("security.enable_ssl2")
	RemoveCurrentPrefsFromFile("security.enable_ssl3")
	RemoveCurrentPrefsFromFile("security.enable_tls")
	set SSLStateSet = AppendPrefsToFile("security.enable_ssl2", "false")
	set SSLStateSet = AppendPrefsToFile("security.enable_ssl3", "false")
	set SSLStateSet = AppendPrefsToFile("security.enable_tls", "false")	
end if


' Disable IDNs?
FirefoxIDNStateType = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxIDNStateType")
FirefoxIDNStateKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxIDNState")
if FirefoxIDNStateKey <> "" then
	if FirefoxIDNStateType = "default" then
		If FirefoxIDNStateKey = "1" then
			RemoveCurrentPrefsFromFile("network.enableIDN")
			set IDNStateSet = AppendDefaultToFile("network.enableIDN", "true")
		ElseIf FirefoxIDNStateKey = "0" then
			RemoveCurrentPrefsFromFile("network.enableIDN")
			set IDNStateSet = AppendDefaultToFile("network.enableIDN", "false")
		end if
	else
		If FirefoxIDNStateKey = "1" then
			RemoveCurrentPrefsFromFile("network.enableIDN")
			set IDNStateSet = AppendPrefsToFile("network.enableIDN", "true")
		ElseIf FirefoxIDNStateKey = "0" then
			RemoveCurrentPrefsFromFile("network.enableIDN")
			set IDNStateSet = AppendPrefsToFile("network.enableIDN", "false")
		end if
	end if
end if

' Disable Password Remembering?
FirefoxPasswordRememberKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxPasswordRememberState")
If FirefoxPasswordRememberKey = "1" then
	RemoveCurrentPrefsFromFile("signon.rememberSignons")
	set PasswordRememberStateSet = AppendPrefsToFile("signon.rememberSignons", "true")
ElseIf FirefoxPasswordRememberKey = "0" then
	RemoveCurrentPrefsFromFile("signon.rememberSignons")
	set PasswordRememberStateSet = AppendPrefsToFile("signon.rememberSignons", "false")
end if


' Enable Type Ahead Find
FirefoxTypeAheadFindTypeKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxTypeAheadFindType")
FirefoxTypeAheadFindKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxTypeAheadFindState")
if FirefoxTypeAheadFindKey <> "" then
	if FirefoxTypeAheadFindTypeKey = "default" then
		If FirefoxTypeAheadFindKey = "1" then
			RemoveCurrentPrefsFromFile("accessibility.typeaheadfind")
			RemovePrefFromFirefoxJs("accessibility.typeaheadfind")
			set FirefoxTypeAheadFindSet = AppendDefaultToFile("accessibility.typeaheadfind", "true")
		ElseIf FirefoxTypeAheadFindKey = "0" then
			RemoveCurrentPrefsFromFile("accessibility.typeaheadfind")
			RemovePrefFromFirefoxJs("accessibility.typeaheadfind")
			set FirefoxTypeAheadFindSet = AppendDefaultToFile("accessibility.typeaheadfind", "false")
		end if
	else
		If FirefoxTypeAheadFindKey = "1" then
			RemoveCurrentPrefsFromFile("accessibility.typeaheadfind")
			set FirefoxTypeAheadFindSet = AppendPrefsToFile("accessibility.typeaheadfind", "true")
		ElseIf FirefoxTypeAheadFindKey = "0" then
			RemoveCurrentPrefsFromFile("accessibility.typeaheadfind")
			set FirefoxTypeAheadFindSet = AppendPrefsToFile("accessibility.typeaheadfind", "false")
		end if
	end if
end if


' Disable Prefetching
FirefoxPrefetchStateKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxPrefetchState")
If FirefoxPrefetchStateKey = "1" then
	RemoveCurrentPrefsFromFile("network.prefetch-next")
	set FirefoxPrefetchState = AppendPrefsToFile("network.prefetch-next", "true")
ElseIf FirefoxPrefetchStateKey = "0" then
	RemoveCurrentPrefsFromFile("network.prefetch-next")
	set FirefoxPrefetchState = AppendPrefsToFile("network.prefetch-next", "false")
end if


' Enable/Disable URL security check
FirefoxSecurityCheckLoadUriKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxSecurityCheckLoadUri")
If FirefoxSecurityCheckLoadUriKey = "1" then
	RemoveCurrentPrefsFromFile("security.checkloaduri")
	set FirefoxSecurityCheckLoadUriSet = AppendPrefsToFile("security.checkloaduri", "false")
ElseIf FirefoxSecurityCheckLoadUriKey = "0" then
	RemoveCurrentPrefsFromFile("security.checkloaduri")
	set FirefoxSecurityCheckLoadUriSet = AppendPrefsToFile("security.checkloaduri", "true")
end if


' Trusted & Delegated Authentication white list
FirefoxTrustedAuthKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxTrustedAuth")
FirefoxDelegatedAuthKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxDelegatedAuth")
If FirefoxTrustedAuthKey <> "" or FirefoxDelegatedAuthKey <> "" then
	RemoveCurrentPrefsFromFile("network.negotiate-auth.trusted-uris")
	RemoveCurrentPrefsFromFile("network.negotiate-auth.delegation-uris")
	set FirefoxTrustedAuthSet = AppendPrefsToFile("network.negotiate-auth.trusted-uris", chr(34) & FirefoxTrustedAuthKey & chr(34))
	set FirefoxDelegatedAuthSet = AppendPrefsToFile("network.negotiate-auth.delegation-uris", chr(34) & FirefoxDelegatedAuthKey & chr(34))
end if


' Trusted NTLM white list
FirefoxTrustedNTLMKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxTrustedNTLM")
If FirefoxTrustedNTLMKey <> "" then
	RemoveCurrentPrefsFromFile("network.automatic-ntlm-auth.trusted-uris")
	RemoveCurrentPrefsFromFile("network.ntlm.send-lm-response")
	set FirefoxTrustedAuthSet = AppendPrefsToFile("network.automatic-ntlm-auth.trusted-uris", chr(34) & FirefoxTrustedNTLMKey & chr(34))
	set FirefoxTrustedAuthSet = AppendPrefsToFile("Network.ntlm.send-lm-response", "true")
end if


' Browse with Caret
FirefoxCaretKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxCaret")
If FirefoxCaretKey = "1" then
	RemoveCurrentPrefsFromFile("accessibility.browsewithcaret")
	set FirefoxCaretSet = AppendPrefsToFile("accessibility.browsewithcaret", "true")
ElseIf FirefoxCaretKey = "0" then
	RemoveCurrentPrefsFromFile("accessibility.browsewithcaret")
	set FirefoxCaretSet = AppendPrefsToFile("accessibility.browsewithcaret", "false")
end if


' Cookie Handling
FirefoxCookieType = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxCookieBehaviourType")
FirefoxCookieKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxCookieBehaviour")
If FirefoxCookieKey <> "" then
	If FirefoxCookieType = "default" then
		RemovePrefFromAllJs("network.cookie.cookieBehavior")
		RemovePrefFromFirefoxJs("network.cookie.cookieBehavior")
		set FirefoxCookieBehaviourKey = AppendDefaultToFile("network.cookie.cookieBehavior", FirefoxCookieKey)
	else
		RemoveCurrentPrefsFromFile("network.cookie.cookieBehavior")
		set FirefoxCookieBehaviourKey = AppendPrefsToFile("network.cookie.cookieBehavior", FirefoxCookieKey)
	end if
end if


' Set Bookmarks Location
FirefoxBookmarksLocationKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxBookmarks")
If FirefoxBookmarksLocationKey <> "" then
	RemoveCurrentPrefsFromFile("browser.bookmarks.file")
	set FirefoxBookmarksKey = AppendPrefsToFile("browser.bookmarks.file", chr(34) & FirefoxBookmarksLocationKey & "\\bookmarks.html" & chr(34))
end if


' Tabs Behaviour
FirefoxTabType = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxTabType")
If FirefoxTabType = "locked" then
	RemoveCurrentPrefsFromFile("browser.link.open_external")
	RemoveCurrentPrefsFromFile("browser.link.open_newwindow")
	RemoveCurrentPrefsFromFile("browser.tabs.loadInBackground")
	RemoveCurrentPrefsFromFile("browser.tabs.warnOnClose")
	RemoveCurrentPrefsFromFile("browser.tabs.warnOnOpen")
	RemoveCurrentPrefsFromFile("browser.tabs.autoHide")
	FirefoxTabNewPage = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxTabNewPage")
	If FirefoxTabNewPage = "Window" then
		set FirefoxTabNewPageKey = AppendPrefsToFile("browser.link.open_external", 2)
		set FirefoxTabNewPageKey2 = AppendPrefsToFile("browser.link.open_newwindow", 2)
	Else
		set FirefoxTabNewPageKey = AppendPrefsToFile("browser.link.open_external", 3)
		set FirefoxTabNewPageKey2 = AppendPrefsToFile("browser.link.open_newwindow", 3)
	end if
	FirefoxTabCloseWarn = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxTabCloseWarn")
	set FirefoxTabCloseWarnKey = AppendPrefsToFile("browser.tabs.warnOnClose", FirefoxTabCloseWarn)
	FirefoxTabOpenWarn = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxTabOpenWarn")
	set FirefoxTabOpenWarnKey = AppendPrefsToFile("browser.tabs.warnOnOpen", FirefoxTabOpenWarn)
	FirefoxTabShowBar = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxTabShowBar")
	set FirefoxTabShowBarKey = AppendPrefsToFile("browser.tabs.autoHide", FirefoxTabShowBar)
	FirefoxTabBackground = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxTabBackground")
	set FirefoxTabBackgroundKey = AppendPrefsToFile("browser.tabs.loadInBackground", FirefoxTabBackground)
ElseIf FirefoxTabType = "default" then
	RemoveCurrentPrefsFromFile("browser.link.open_external")
	RemoveCurrentPrefsFromFile("browser.link.open_newwindow")
	RemoveCurrentPrefsFromFile("browser.tabs.loadInBackground")
	RemoveCurrentPrefsFromFile("browser.tabs.warnOnClose")
	RemoveCurrentPrefsFromFile("browser.tabs.warnOnOpen")
	RemoveCurrentPrefsFromFile("browser.tabs.autoHide")
	RemovePrefFromFirefoxJs("browser.link.open_external")
	RemovePrefFromFirefoxJs("browser.link.open_newwindow")
	RemovePrefFromFirefoxJs("browser.tabs.loadInBackground")
	RemovePrefFromFirefoxJs("browser.tabs.warnOnClose")
	RemovePrefFromFirefoxJs("browser.tabs.warnOnOpen")
	RemovePrefFromFirefoxJs("browser.tabs.autoHide")
	RemovePrefFromAllJs("browser.tabs.warnOnClose")
	RemovePrefFromAllJs("browser.tabs.warnOnOpen")
	RemovePrefFromAllJs("browser.tabs.autoHide")
	FirefoxTabNewPage = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxTabNewPage")
	If FirefoxTabNewPage = "Window" then
		set FirefoxTabNewPageKey = AppendDefaultToFile("browser.link.open_external", 2)
		set FirefoxTabNewPageKey2 = AppendDefaultToFile("browser.link.open_newwindow", 2)
	Else
		set FirefoxTabNewPageKey = AppendDefaultToFile("browser.link.open_external", 3)
		set FirefoxTabNewPageKey2 = AppendDefaultToFile("browser.link.open_newwindow", 3)
	end if
	FirefoxTabCloseWarn = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxTabCloseWarn")
	set FirefoxTabCloseWarnKey = AppendDefaultToFile("browser.tabs.warnOnClose", FirefoxTabCloseWarn)
	FirefoxTabOpenWarn = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxTabOpenWarn")
	set FirefoxTabOpenWarnKey = AppendDefaultToFile("browser.tabs.warnOnOpen", FirefoxTabOpenWarn)
	FirefoxTabShowBar = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxTabShowBar")
	set FirefoxTabShowBarKey = AppendDefaultToFile("browser.tabs.autoHide", FirefoxTabShowBar)
	FirefoxTabBackground = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxTabBackground")
	set FirefoxTabBackgroundKey = AppendDefaultToFile("browser.tabs.loadInBackground", FirefoxTabBackground)
end if		


' History
FirefoxHistoryType = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxHistoryType")
If FirefoxHistoryType = "locked" then
	RemoveCurrentPrefsFromFile("browser.history_expire_days")
	RemoveCurrentPrefsFromFile("browser.history_expire_days_min")
	RemoveCurrentPrefsFromFile("browser.history_expire_days.mirror")
	RemoveCurrentPrefsFromFile("browser.formfill.enable")
	RemoveCurrentPrefsFromFile("browser.download.manager.retention")
	FirefoxHistoryPage = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxHistoryDays")
	set FirefoxHistoryPageKey = AppendPrefsToFile("browser.history_expire_days", FirefoxHistoryPage)
	set FirefoxHistoryPage2Key = AppendPrefsToFile("browser.history_expire_days.mirror", FirefoxHistoryPage)
	set FirefoxHistoryPage3Key = AppendPrefsToFile("browser.history_expire_days_min", FirefoxHistoryPage)
	FirefoxHistoryPage = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxHistoryForms")
	set FirefoxHistoryPageKey = AppendPrefsToFile("browser.formfill.enable", FirefoxHistoryPage)
	FirefoxHistoryPage = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxHistoryDownloads")
	set FirefoxHistoryPageKey = AppendPrefsToFile("browser.download.manager.retention", FirefoxHistoryPage)
ElseIf FirefoxHistoryType = "default" then
	RemoveCurrentPrefsFromFile("browser.history_expire_days")
	RemoveCurrentPrefsFromFile("browser.history_expire_days_min")
	RemoveCurrentPrefsFromFile("browser.history_expire_days.mirror")
	RemoveCurrentPrefsFromFile("browser.formfill.enable")
	RemoveCurrentPrefsFromFile("browser.download.manager.retention")
	RemovePrefFromAllJs("browser.history_expire_days")
	RemovePrefFromFirefoxJs("browser.history_expire_days")
	RemovePrefFromFirefoxJs("browser.history_expire_days_min")
	RemovePrefFromFirefoxJs("browser.formfill.enable")
	RemovePrefFromFirefoxJs("browser.download.manager.retention")
	FirefoxHistoryPage = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxHistoryDays")
	set FirefoxHistoryPageKey = AppendDefaultToFile("browser.history_expire_days", FirefoxHistoryPage)
	set FirefoxHistoryPage2Key = AppendDefaultToFile("browser.history_expire_days.mirror", FirefoxHistoryPage)
	set FirefoxHistoryPage3Key = AppendDefaultToFile("browser.history_expire_days_min", FirefoxHistoryPage)
	FirefoxHistoryPage = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxHistoryForms")
	set FirefoxHistoryPageKey = AppendDefaultToFile("browser.formfill.enable", FirefoxHistoryPage)
	FirefoxHistoryPage = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxHistoryDownloads")
	set FirefoxHistoryPageKey = AppendDefaultToFile("browser.download.manager.retention", FirefoxHistoryPage)
end if


' Private Data
FirefoxDataType = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxDataType")
If FirefoxDataType = "locked" then
	RemoveCurrentPrefsFromFile("privacy.sanitize.sanitizeOnShutdown")
	RemoveCurrentPrefsFromFile("privacy.sanitize.promptOnSanitize")
	FirefoxDataClear = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxDataClear")
	set FirefoxDataClearKey = AppendPrefsToFile("privacy.sanitize.sanitizeOnShutdown", FirefoxDataClear)
	FirefoxDataPrompt = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxDataPrompt")
	set FirefoxDataClearKey = AppendPrefsToFile("privacy.sanitize.promptOnSanitize", FirefoxDataPrompt)
ElseIf FirefoxDataType = "default" then
	RemoveCurrentPrefsFromFile("privacy.sanitize.sanitizeOnShutdown")
	RemoveCurrentPrefsFromFile("privacy.sanitize.promptOnSanitize")
	RemovePrefFromFirefoxJs("privacy.sanitize.sanitizeOnShutdown")
	RemovePrefFromFirefoxJs("privacy.sanitize.promptOnSanitize")
	FirefoxDataClear = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxDataClear")
	set FirefoxDataClearKey = AppendDefaultToFile("privacy.sanitize.sanitizeOnShutdown", FirefoxDataClear)
	FirefoxDataPrompt = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxDataPrompt")
	set FirefoxDataClearKey = AppendDefaultToFile("privacy.sanitize.promptOnSanitize", FirefoxDataPrompt)
end if


' Browsing Options
FirefoxBrowsingType = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxBrowsingType")
If FirefoxBrowsingType = "locked" then
	RemoveCurrentPrefsFromFile("general.autoScroll")
	RemoveCurrentPrefsFromFile("general.smoothScroll")
	RemoveCurrentPrefsFromFile("layout.spellcheckDefault")
	FirefoxAutoScroll = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxAutoScroll")
	set FirefoxAutoScrollKey = AppendPrefsToFile("general.autoScroll", FirefoxAutoScroll)
	FirefoxSmoothScroll = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxSmoothScroll")
	set FirefoxSmoothScrollKey = AppendPrefsToFile("general.smoothScroll", FirefoxSmoothScroll)
	FirefoxCheckSpell = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxCheckSpell")
	set FirefoxCheckSpellKey = AppendPrefsToFile("layout.spellcheckDefault", FirefoxCheckSpell)
ElseIf FirefoxBrowsingType = "default" then
	RemoveCurrentPrefsFromFile("general.autoScroll")
	RemoveCurrentPrefsFromFile("general.smoothScroll")
	RemoveCurrentPrefsFromFile("layout.spellcheckDefault")
	RemovePrefFromFirefoxJs("general.autoScroll")
	RemovePrefFromFirefoxJs("general.smoothScroll")
	RemovePrefFromFirefoxJs("layout.spellcheckDefault")
	FirefoxAutoScroll = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxAutoScroll")
	set FirefoxAutoScrollKey = AppendDefaultToFile("general.autoScroll", FirefoxAutoScroll)
	FirefoxSmoothScroll = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxSmoothScroll")
	set FirefoxSmoothScrollKey = AppendDefaultToFile("general.smoothScroll", FirefoxSmoothScroll)
	FirefoxCheckSpell = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxCheckSpell")
	set FirefoxCheckSpellKey = AppendDefaultToFile("layout.spellcheckDefault", FirefoxCheckSpell)
end if


' Save Form Data
FirefoxSaveFormDataType = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxSaveFormDataType")
FirefoxSaveFormDataKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxSaveFormData")
if FirefoxSaveFormDataKey = "0" then
	RemoveCurrentPrefsFromFile("browser.formfill.enable")
	if FirefoxSaveFormDataType = "default" then
		RemovePrefFromFirefoxJs("browser.formfill.enable")
		set DefaultSet = AppendDefaultToFile("browser.formfill.enable", "false")
	else
		set DefaultSet = AppendPrefsToFile("browser.formfill.enable", "false")
	end if
Elseif FirefoxSaveFormDataKey = "1" then
	RemoveCurrentPrefsFromFile("browser.formfill.enable")
	if FirefoxSaveFormDataType = "default" then
		RemovePrefFromFirefoxJs("browser.formfill.enable")
		set DefaultSet = AppendDefaultToFile("browser.formfill.enable", "true")
	else
		set DefaultSet = AppendPrefsToFile("browser.formfill.enable", "true")
	end if
end if


' Delete Private Data Cookies
FirefoxDelPrivDataCookiesType = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxDelPrivDataCookiesType")
FirefoxDelPrivDataCookiesKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxDelPrivDataCookies")
if FirefoxDelPrivDataCookiesKey = "0" then
	RemoveCurrentPrefsFromFile("privacy.item.cookies")
	if FirefoxDelPrivDataCookiesType = "default" then
		RemovePrefFromFirefoxJs("privacy.item.cookies")
		set DefaultSet = AppendDefaultToFile("privacy.item.cookies", "false")
	else
		set DefaultSet = AppendPrefsToFile("privacy.item.cookies", "false")
	end if
Elseif FirefoxDelPrivDataCookiesKey = "1" then
	RemoveCurrentPrefsFromFile("privacy.item.cookies")
	if FirefoxDelPrivDataCookiesType = "default" then
		RemovePrefFromFirefoxJs("privacy.item.cookies")
		set DefaultSet = AppendDefaultToFile("privacy.item.cookies", "true")
	else
		set DefaultSet = AppendPrefsToFile("privacy.item.cookies", "true")
	end if
end if


' Delete Private Data Offline Websites
FirefoxDelPrivDataOfflineWebsitesType = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxDelPrivDataOfflineWebsitesType")
FirefoxDelPrivDataOfflineWebsitesKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxDelPrivDataOfflineWebsites")
if FirefoxDelPrivDataOfflineWebsitesKey = "0" then
	RemoveCurrentPrefsFromFile("privacy.item.offlineApps")
	if FirefoxDelPrivDataOfflineWebsitesType = "default" then
		RemovePrefFromFirefoxJs("privacy.item.offlineApps")
		set DefaultSet = AppendDefaultToFile("privacy.item.offlineApps", "false")
	else
		set DefaultSet = AppendPrefsToFile("privacy.item.offlineApps", "false")
	end if
Elseif FirefoxDelPrivDataOfflineWebsitesKey = "1" then
	RemoveCurrentPrefsFromFile("privacy.item.offlineApps")
	if FirefoxDelPrivDataOfflineWebsitesType = "default" then
		RemovePrefFromFirefoxJs("privacy.item.offlineApps")
		set DefaultSet = AppendDefaultToFile("privacy.item.offlineApps", "true")
	else
		set DefaultSet = AppendPrefsToFile("privacy.item.offlineApps", "true")
	end if
end if


' Delete Private Data Passwords
FirefoxDelPrivDataPasswordsType = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxDelPrivDataPasswordsType")
FirefoxDelPrivDataPasswordsKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxDelPrivDataPasswords")
if FirefoxDelPrivDataPasswordsKey = "0" then
	RemoveCurrentPrefsFromFile("privacy.item.passwords")
	if FirefoxDelPrivDataPasswordsType = "default" then
		RemovePrefFromFirefoxJs("privacy.item.passwords")
		set DefaultSet = AppendDefaultToFile("privacy.item.passwords", "false")
	else
		set DefaultSet = AppendPrefsToFile("privacy.item.passwords", "false")
	end if
Elseif FirefoxDelPrivDataPasswordsKey = "1" then
	RemoveCurrentPrefsFromFile("privacy.item.passwords")
	if FirefoxDelPrivDataPasswordsType = "default" then
		RemovePrefFromFirefoxJs("privacy.item.passwords")
		set DefaultSet = AppendDefaultToFile("privacy.item.passwords", "true")
	else
		set DefaultSet = AppendPrefsToFile("privacy.item.passwords", "true")
	end if
end if


' Show SSL Domain Icon
FirefoxShowSSLDomainIconType = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxShowSSLDomainIconType")
FirefoxShowSSLDomainIconKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxShowSSLDomainIcon")
if FirefoxShowSSLDomainIconKey = "0" then
	RemoveCurrentPrefsFromFile("browser.identity.ssl_domain_display")
	if FirefoxShowSSLDomainIconType = "default" then
		RemovePrefFromFirefoxJs("browser.identity.ssl_domain_display")
		set DefaultSet = AppendDefaultToFile("browser.identity.ssl_domain_display", "0")
	else
		set DefaultSet = AppendPrefsToFile("browser.identity.ssl_domain_display", "0")
	end if
Elseif FirefoxShowSSLDomainIconKey = "1" then
	RemoveCurrentPrefsFromFile("browser.identity.ssl_domain_display")
	if FirefoxShowSSLDomainIconType = "default" then
		RemovePrefFromFirefoxJs("browser.identity.ssl_domain_display")
		set DefaultSet = AppendDefaultToFile("browser.identity.ssl_domain_display", "1")
	else
		set DefaultSet = AppendPrefsToFile("browser.identity.ssl_domain_display", "1")
	end if
end if


' Use Download Directory
FirefoxUseDownloadDirType = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxUseDownloadDirType")
FirefoxUseDownloadDirKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxUseDownloadDir")
if FirefoxUseDownloadDirKey = "0" then
	RemoveCurrentPrefsFromFile("browser.download.useDownloadDir")
	if FirefoxUseDownloadDirType = "default" then
		RemovePrefFromFirefoxJs("browser.download.useDownloadDir")
		set DefaultSet = AppendDefaultToFile("browser.download.useDownloadDir", "false")
	else
		set DefaultSet = AppendPrefsToFile("browser.download.useDownloadDir", "false")
	end if
Elseif FirefoxUseDownloadDirKey = "1" then
	RemoveCurrentPrefsFromFile("browser.download.useDownloadDir")
	if FirefoxUseDownloadDirType = "default" then
		RemovePrefFromFirefoxJs("browser.download.useDownloadDir")
		set DefaultSet = AppendDefaultToFile("browser.download.useDownloadDir", "true")
	else
		set DefaultSet = AppendPrefsToFile("browser.download.useDownloadDir", "true")
	end if
end if


' Replace Certificates for all User Profiles
FirefoxCertificatesLocationKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxCertificateLocation")
if FirefoxCertificatesLocationKey <> "" then
	FirefoxMandatoryCertificatesKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxMandatoryCertificates")
	if (FirefoxMandatoryCertificatesKey = "Merge" OR FirefoxMandatoryCertificatesKey = "Replace") then
		set EnVar = Wshshell.environment("Process")
		DocSettingsPath = Left(EnVar("ALLUSERSPROFILE"),Len(EnVar("ALLUSERSPROFILE"))-9)
		Set objFolder = fso.GetFolder(DocSettingsPath)
		Set colSubfolders = objFolder.Subfolders
		for each objSubfolder in colSubfolders
			if (objFSO.FolderExists(DocSettingsPath&objSubfolder.Name)) then
				if (objFSO.FolderExists(DocSettingsPath&objSubfolder.Name&"\Application Data")) then
					if (objFSO.FolderExists(DocSettingsPath&objSubfolder.Name&"\Application Data\Mozilla")) then
						if (objFSO.FolderExists(DocSettingsPath&objSubfolder.Name&"\Application Data\Mozilla\Firefox")) then
							if (objFSO.FolderExists(DocSettingsPath&objSubfolder.Name&"\Application Data\Mozilla\Firefox\Profiles")) then
								Set objFolderProf = fso.GetFolder(DocSettingsPath&objSubfolder.Name&"\Application Data\Mozilla\Firefox\Profiles")
								Set colSubfoldersProf = objFolderProf.Subfolders
								For Each objSubfolderProf in colSubfoldersProf
									if FirefoxMandatoryCertificatesKey = "Merge" then
										if fso.FileExists(DocSettingsPath&objSubfolder.Name&"\Application Data\Mozilla\Firefox\Profiles\"&objSubfolderProf.Name & "\cert8.db") = false then
											if fso.FileExists(FirefoxCertificatesLocationKey & "\cert8.db") then
												fso.CopyFile FirefoxCertificatesLocationKey & "\cert8.db", DocSettingsPath&objSubfolder.Name&"\Application Data\Mozilla\Firefox\Profiles\"&objSubfolderProf.Name & "\cert8.db"
											end if
										end if
										if fso.FileExists(DocSettingsPath&objSubfolder.Name&"\Application Data\Mozilla\Firefox\Profiles\"&objSubfolderProf.Name & "\key3.db") = false then
											if fso.FileExists(FirefoxCertificatesLocationKey & "\key3.db") then
												fso.CopyFile FirefoxCertificatesLocationKey & "\key3.db", DocSettingsPath&objSubfolder.Name&"\Application Data\Mozilla\Firefox\Profiles\"&objSubfolderProf.Name & "\key3.db"
											end if
										end if
										if fso.FileExists(DocSettingsPath&objSubfolder.Name&"\Application Data\Mozilla\Firefox\Profiles\"&objSubfolderProf.Name & "\secmod.db") = false then
											if fso.FileExists(FirefoxCertificatesLocationKey & "\secmod.db") then
												fso.CopyFile FirefoxCertificatesLocationKey & "\secmod.db", DocSettingsPath&objSubfolder.Name&"\Application Data\Mozilla\Firefox\Profiles\"&objSubfolderProf.Name & "\secmod.db"
											end if
										end if
									else
										if fso.FileExists(FirefoxCertificatesLocationKey & "\cert8.db") then
											fso.CopyFile FirefoxCertificatesLocationKey & "\cert8.db", DocSettingsPath&objSubfolder.Name&"\Application Data\Mozilla\Firefox\Profiles\"&objSubfolderProf.Name & "\cert8.db"
										end if
										if fso.FileExists(FirefoxCertificatesLocationKey & "\key3.db") then
											fso.CopyFile FirefoxCertificatesLocationKey & "\key3.db", DocSettingsPath&objSubfolder.Name&"\Application Data\Mozilla\Firefox\Profiles\"&objSubfolderProf.Name & "\key3.db"
										end if
										if fso.FileExists(FirefoxCertificatesLocationKey & "\secmod.db") then
											fso.CopyFile FirefoxCertificatesLocationKey & "\secmod.db", DocSettingsPath&objSubfolder.Name&"\Application Data\Mozilla\Firefox\Profiles\"&objSubfolderProf.Name & "\secmod.db"
										end if
									end if
								next
							end if
						end if
					end if
				end if
			end if
		next
	end if
end if


' Suppress Update Message
FirefoxSupressUpdatePageKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxSupressUpdatePage")
If FirefoxSupressUpdatePageKey = "1" then
	RemoveCurrentPrefsFromFile("startup.homepage_override_url")
	RemoveCurrentPrefsFromFile("startup.homepage_welcome_url")
	set FirefoxSupressUpdateKey = AppendPrefsToFile("startup.homepage_override_url", chr(34) & chr(34))
	set FirefoxSupressUpdateKey = AppendPrefsToFile("startup.homepage_welcome_url", chr(34) & chr(34))
ElseIf FirefoxSupressUpdatePage = "0" then
	RemoveCurrentPrefsFromFile("startup.homepage_override_url")
	RemoveCurrentPrefsFromFile("startup.homepage_welcome_url")
end if


' Disable IPv6
FirefoxDisableIPv6Key = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxDisableIPv6")
If FirefoxDisableIPv6Key = "1" then
	RemoveCurrentPrefsFromFile("network.dns.disableIPv6")
	set DisableIPv6Key = AppendPrefsToFile("network.dns.disableIPv6", "true")
end if


' Display Warning Messages
FirefoxWarningEnteringSecureKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxWarningEnteringSecure")
If FirefoxWarningEnteringSecureKey = "1" then
	RemoveCurrentPrefsFromFile("security.warn_entering_secure")
	set WarningEnteringSecureKey = AppendPrefsToFile("security.warn_entering_secure", "true")
ElseIf FirefoxWarningEnteringSecureKey = "0" then
	RemoveCurrentPrefsFromFile("security.warn_entering_secure")
	set WarningEnteringSecureKey = AppendPrefsToFile("security.warn_entering_secure", "false")
end if
FirefoxWarningEnteringWeakKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxWarningEnteringWeak")
If FirefoxWarningEnteringWeakKey = "1" then
	RemoveCurrentPrefsFromFile("security.warn_entering_weak")
	set WarningEnteringWeakKey = AppendPrefsToFile("security.warn_entering_weak", "true")
ElseIf FirefoxWarningEnteringWeakKey = "0" then
	RemoveCurrentPrefsFromFile("security.warn_entering_weak")
	set WarningEnteringWeakKey = AppendPrefsToFile("security.warn_entering_weak", "false")
end if
FirefoxWarningLeavingSecureKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxWarningLeavingSecure")
If FirefoxWarningLeavingSecureKey = "1" then
	RemoveCurrentPrefsFromFile("security.warn_leaving_secure")
	set WarningLeavingSecureKey = AppendPrefsToFile("security.warn_leaving_secure", "true")
ElseIf FirefoxWarningLeavingSecureKey = "0" then
	RemoveCurrentPrefsFromFile("security.warn_leaving_secure")
	set WarningLeavingSecureKey = AppendPrefsToFile("security.warn_leaving_secure", "false")
end if
FirefoxWarningSubmitInsecureKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxWarningSubmitInsecure")
If FirefoxWarningSubmitInsecureKey = "1" then
	RemoveCurrentPrefsFromFile("security.warn_submit_insecure")
	set WarningSubmitInsecureKey = AppendPrefsToFile("security.warn_submit_insecure", "true")
ElseIf FirefoxWarningSubmitInsecureKey = "0" then
	RemoveCurrentPrefsFromFile("security.warn_submit_insecure")
	set WarningSubmitInsecureKey = AppendPrefsToFile("security.warn_submit_insecure", "false")
end if
FirefoxWarningViewingMixedKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxWarningViewingMixed")
If FirefoxWarningViewingMixedKey = "1" then
	RemoveCurrentPrefsFromFile("security.warn_viewing_mixed")
	set WarningViewingMixedKey = AppendPrefsToFile("security.warn_viewing_mixed", "true")
ElseIf FirefoxWarningViewingMixedKey = "0" then
	RemoveCurrentPrefsFromFile("security.warn_viewing_mixed")
	set WarningViewingMixedKey = AppendPrefsToFile("security.warn_viewing_mixed", "false")
end if


' Phishing Protection
FirefoxPhishProtectKey = WshShell.regread("HKLM\Software\Policies\Firefox\FirefoxPhishProtect")
If FirefoxPhishProtectKey = "1" then
	RemoveCurrentPrefsFromFile("browser.safebrowsing.enabled")
	RemoveCurrentPrefsFromFile("browser.safebrowsing.malware.enabled")
	set PhishProtectKey = AppendPrefsToFile("browser.safebrowsing.enabled", "true")
	set MalwareProtectKey = AppendPrefsToFile("browser.safebrowsing.malware.enabled", "true")
ElseIf FirefoxPhishProtectKey = "0" then
	RemoveCurrentPrefsFromFile("browser.safebrowsing.enabled")
	RemoveCurrentPrefsFromFile("browser.safebrowsing.malware.enabled")
	set PhishProtectKey = AppendPrefsToFile("browser.safebrowsing.enabled", "false")
	set MalwareProtectKey = AppendPrefsToFile("browser.safebrowsing.malware.enabled", "false")
end if


' TODO:  More settings!


Function RemoveCurrentPrefsFromFile(removeSetting)
	Set ParsePrefsFile = fso.OpenTextFile(FirefoxPrefsFile, ForReading)

	' Get file content into an array:
	Dim aContents
	aContents = Split(ParsePrefsFile.ReadAll, vbCrLf)

	ParsePrefsFile.Close
	set ParsePrefsFile = Nothing

	' Parse Back In to Prefs.js file

	Dim aContentsNew
	aContentsNew = Filter(aContents, chr(34) & removeSetting & chr(34), False, vbTextCompare)

	' Overwrite the old file with the new file,
  	Set ParseOutPrefsFile = fso.OpenTextFile(FirefoxPrefsFile, ForWriting)
  	ParseOutPrefsFile.Write Join(aContentsNew, vbCrLf)
    	ParseOutPrefsFile.Close
End Function

Function RemovePrefFromAllJs(removeSetting)
	Set ParsePrefsFile = fso.OpenTextFile(FirefoxAllJsFile, ForReading)

	' Get file content into an array:
	Dim aContents
	aContents = Split(ParsePrefsFile.ReadAll, vbCrLf)

	ParsePrefsFile.Close
	set ParsePrefsFile = Nothing

	' Parse Back In to all.js file

	Dim aContentsNew
	aContentsNew = Filter(aContents, chr(34) & removeSetting & chr(34), False, vbTextCompare)

	' Overwrite the old file with the new file,
  	Set ParseOutPrefsFile = fso.OpenTextFile(FirefoxAllJsFile, ForWriting)
  	ParseOutPrefsFile.Write Join(aContentsNew, vbCrLf)
    	ParseOutPrefsFile.Close
End Function

Function RemovePrefFromFirefoxJs(removeSetting)
	Set ParsePrefsFile = fso.OpenTextFile(FirefoxJsFile, ForReading)

	' Get file content into an array:
	Dim aContents
	aContents = Split(ParsePrefsFile.ReadAll, vbCrLf)

	ParsePrefsFile.Close
	set ParsePrefsFile = Nothing

	' Parse Back In to all.js file

	Dim aContentsNew
	aContentsNew = Filter(aContents, chr(34) & removeSetting & chr(34), False, vbTextCompare)

	' Overwrite the old file with the new file,
  	Set ParseOutPrefsFile = fso.OpenTextFile(FirefoxJsFile, ForWriting)
  	ParseOutPrefsFile.Write Join(aContentsNew, vbCrLf)
    	ParseOutPrefsFile.Close
End Function

Function RemovePrefFromXpinstallJs(removeSetting)
	Set ParsePrefsFile = fso.OpenTextFile(FirefoxXpinstallJsFile, ForReading)

	' Get file content into an array:
	Dim aContents
	aContents = Split(ParsePrefsFile.ReadAll, vbCrLf)

	ParsePrefsFile.Close
	set ParsePrefsFile = Nothing

	' Parse Back In to all.js file

	Dim aContentsNew
	aContentsNew = Filter(aContents, chr(34) & removeSetting & chr(34), False, vbTextCompare)

	' Overwrite the old file with the new file,
  	Set ParseOutPrefsFile = fso.OpenTextFile(FirefoxXpinstallJsFile, ForWriting)
  	ParseOutPrefsFile.Write Join(aContentsNew, vbCrLf)
    	ParseOutPrefsFile.Close
End Function

Function SetDefaultHomePage(homepage)
	Set ParseOutPrefsFile = fso.OpenTextFile(FirefoxBrowserconfigPropertiesFile, ForWriting)
	ParseOutPrefsFile.WriteLine("browser.startup.homepage=" & homepage)
	ParseOutPrefsFile.WriteLine("browser.startup.homepage_reset=" & homepage)
	ParseOutPrefsFile.Close
End Function

Function AppendPrefsToFile(writeKey, writeData)
	set PrefsFile = fso.OpenTextFile(FirefoxPrefsFile,ForAppending)
	PrefsFile.Write (vbCrLf & "lockPref(" & chr(34) & writeKey & chr(34) & ", " & writeData & ");")
	PrefsFile.Close
End Function

Function AppendDefaultToFile(writeKey, writeData)
	set PrefsFile = fso.OpenTextFile(FirefoxPrefsFile,ForAppending)
	PrefsFile.Write (vbCrLf & "defaultPref(" & chr(34) & writeKey & chr(34) & ", " & writeData & ");")
	PrefsFile.Close
End Function

Function RemoveConfigSetting()
	Set ParsePrefsFile = fso.OpenTextFile(FirefoxJsFile, ForReading)

	' Get file content into an array:
	Dim aContents
	aContents = Split(ParsePrefsFile.ReadAll, vbCrLf)

	ParsePrefsFile.Close
	set ParsePrefsFile = Nothing

	' Parse Back In to Firefox.js file

	Dim aContentsNew
	aContentsNew = Filter(aContents, chr(34) & "general.config.filename" & chr(34), False, vbTextCompare)

	' Overwrite the old file with the new file,
  	Set ParseOutPrefsFile = fso.OpenTextFile(FirefoxJsFile, ForWriting)
  	ParseOutPrefsFile.Write Join(aContentsNew, vbCrLf)
    	ParseOutPrefsFile.Close
End Function